using System;
using System.Linq;

namespace Zlatnici
{
    class Program
    {
        class Unos
        {
            public int prvi, drugi;
            public Unos()
            {
                prvi = 0;
                drugi = 0;
            }
            public Unos(int a, int b)
            {
                prvi = a;
                drugi = b;
            }
        }
        public void Zamena()
        {

        }
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine());
            Unos[] pozicije = new Unos[N];
            int[,] zlatnici = new int[N, N];
            int[] neX = new int[N];
            int[] neY = new int[N];
            if (N > 0 && N < 2 * Math.Pow(10, 5))
            {
                for (int i = 0; i < N; i++)
                {
                    string[] niz = Console.ReadLine().Split(' ');
                    pozicije[i] = new Unos(int.Parse(niz[0]), int.Parse(niz[1]));
                    neX[i] = int.Parse(niz[0]);
                    neY[i] = int.Parse(niz[1]);
                    if (neX[i] < 0 || neX[i] > N || neY[i] < 0 || neY[i] > N)
                    {
                        goto end;
                    }
                }
                for (int i = 0; i < N - 1; i++)
                {
                    for (int j = i + 1; j < N; j++)
                    {
                        if (neX[i] == neX[j] && neY[i] == neY[j])
                        {
                            goto end;
                        }
                    }
                }
                int[] px = new int[N];
                int[] py = new int[N];
                for (int i = 0; i < N; i++)
                {
                    zlatnici[(pozicije[i].drugi - 1), (pozicije[i].prvi - 1)] = 1;
                    px[i] = pozicije[i].drugi - 1;
                    py[i] = pozicije[i].prvi - 1;
                }
                for (int i = 0; i < N; i++)
                {
                    for (int j = 0; j < N; j++)
                    {
                        if (zlatnici[i, j] != 1)
                        {
                            zlatnici[i, j] = 0;
                        }
                    }
                }
                int br = 0;
                int[] zauzeto = new int[N];
                int vreme = 0;
                int za = 0;
                while (true)
                {
                    for (int i = 0; i < N; i++)
                    {
                        br = 0;
                        for (int j = 0; j < N; j++)
                        {
                            if (zlatnici[i, j] == 1)
                            {
                                br++;
                            }
                        }
                        if (br != 0)
                        {
                            zauzeto[i] = 2;
                        }
                        else
                        {
                            zauzeto[i] = 3;
                        }
                    }
                    for (int i = 0; i < N-1; i++)
                    {
                        for (int j = 0; j < N; j++) {
                            if (zauzeto[i] == 3)
                            {
                                if (zlatnici[i + 1, j] == 1)
                                {
                                    zlatnici[i, j] = 1;
                                    zlatnici[i + 1, j] = 0;
                                    zauzeto[i] = 2;
                                    vreme++; 
                                }
                            }
                        }
                    }
                    for (int i = 0; i < N; i++)
                    {
                        if(zauzeto[i] == 2)
                        {
                            za++;
                        }
                    }
                    if(za == N)
                    {
                        break;
                    }

                }
                Console.WriteLine(za);
                }
            end:;
        }
    }
}